package com.sencorsta.rabs.obj.ai.scene.activity;

import cn.hutool.core.thread.ThreadUtil;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sencorsta.rabs.annotation.SceneAnnotation;
import com.sencorsta.rabs.obj.ai.AiManage;
import com.sencorsta.rabs.obj.ai.api.BaseScene;
import com.sencorsta.rabs.obj.ai.api.Scene;

import java.awt.AWTException;

/**
 * 活动
 */
@SceneAnnotation("SceneMain")
public class SceneMain_Activity extends BaseScene implements Scene {
    @JsonIgnore
    @Override
    public float getPriority() {
        return 0.9f;
    }

    private static String PathEnter = System.getProperty("user.dir") + "\\opencv\\scene\\activity\\enter.png";
    private static String PathCheck = System.getProperty("user.dir") + "\\opencv\\scene\\activity\\check.png";
    private static String PathBack = System.getProperty("user.dir") + "\\opencv\\scene\\activity\\back.png";
    private static String PathBingo = System.getProperty("user.dir") + "\\opencv\\scene\\activity\\bingo.png";
    private static String PathBingoDo = System.getProperty("user.dir") + "\\opencv\\scene\\activity\\bingoDo.png";

    @Override
    public void back() throws AWTException {
        moveToClick(PathBack, AiManage.getInstance().getCheckPoint());
    }

    @Override
    public void open() throws AWTException {
        while (AiManage.getInstance().isRunning() && !check()) {
            AiManage.getInstance().updateWindow();
            ThreadUtil.sleep(2000);
            if (checkHas(PathEnter, AiManage.getInstance().getCheckPoint())) {
                moveToClick(PathEnter, AiManage.getInstance().getCheckPoint());
                continue;
            }
        }
    }

    @Override
    public boolean check() throws AWTException {
        if (checkHas(PathCheck, AiManage.getInstance().getCheckPoint())) {
            return true;
        }
        return false;
    }

    @Override
    public void think() throws AWTException {
        if (checkHas(PathBingo, AiManage.getInstance().getCheckPoint())) {
            moveToClick(PathBingo, AiManage.getInstance().getCheckPoint());
            ThreadUtil.sleep(2000);

            if (checkHas(PathBingoDo,AiManage.getInstance().getCheckPoint())){
                moveToClick(PathBingoDo, AiManage.getInstance().getCheckPoint());
                ThreadUtil.sleep(3000);
            }

            getRecord().getData().setDone(true);
        }

    }

    @Override
    public boolean isDone() {
        return getRecord().getData().isDone();
    }

}
